#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <dir.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <alloc.h>
#include <mem.h>
#include <errno.h>
#include "dram.h"

#define TRUE    1
#define FALSE   0

char gtpath[128]      = "";
char lan_path[128]    = "";
char bbs_path[128]    = "";
char mailbox_dir[128] = "";
long default_max_msgs = 100;
long default_max_k    = 500;
long default_max_days = 180;
FILE *report          = NULL;
long mailbox_count    = 0;

void main(int,char *[]);
void wf_printf(char*,...);
char *splice(char*,char*,char*);

extern unsigned _stklen = 32768U;
extern char *farPtr(char*,long);

int public_area;

void FileDelete(char *fpath,char *fname)
{
    char work[128];
    char dpath[128];
    char far *dta;
    int result;
    struct ffblk ffblk;

    if (fpath[0])
	splice(work,fpath,fname);
    else
	strcpy(work,fname);
    dta = getdta();
    result = findfirst(work,&ffblk,0);
    while (result >= 0) {
	setdta(dta);
	if (ffblk.ff_name[0] != '.') {
	    if (fpath[0])
		splice(dpath,fpath,ffblk.ff_name);
	    else
		strcpy(dpath,ffblk.ff_name);
	    unlink(dpath);
	}
	result = findnext(&ffblk);
    }
    setdta(dta);
}

char *splice(char *os,char *s1,char *s2)
{
    int i, j, ch, has_slash;

    has_slash = 0;
    for (j=0; (ch = os[j] = s1[j]); j++) {
        if (ch == '\\')
            has_slash = 1;
        else
            has_slash = 0;
    }
    if (!has_slash)
        os[j++] = '\\';
    for (i=0; (os[j++] = s2[i++]); )
        ;
    strupr(os);
    return(os);
}

int FileCopy(
    char *dest_path, char *dest_name,
    char *src_path,  char *src_name
    )
{
    char srcname[128], destname[128];
    unsigned datep, timep;
    char fbuf[4112];
    int src, dest;
    long bytesread;

    if (src_path[0])
	splice(srcname,src_path,src_name);
    else
	strcpy(srcname,src_name);
    if ((src = _open(srcname,o_mode(O_RDONLY))) < 0)
	return(0);
    _dos_getftime(src,&datep,&timep);
    if (dest_path[0])
	splice(destname,dest_path,dest_name);
    else
	strcpy(destname,dest_name);
    if ((dest = createfile(destname)) < 0) {
	_close(src);
	return(0);
    }
    do {
	if ((bytesread = readfile(src,fbuf,4096)) > 0)
	    writefile(dest,fbuf,bytesread);
    } while (bytesread == 4096L);
    _dos_setftime(dest,datep,timep);
    _close(dest);
    _close(src);
    return(1);
}

void wf_printf(char *fmt,...)
{
    va_list argptr;

    va_start(argptr,fmt);
    vprintf(fmt,argptr);
    va_end(argptr);
}

void WinDelay(int t)
{
    delay(t);
}

void mak_dir(char *s)
{
    int j;
    char temp[128];

    strcpy(temp,s);
    if ((j = strlen(temp) - 1) <= 0)
        return;
    if (temp[j] == '\\')
        temp[j] = 0;
    mkdir(temp);
}

char *build_time(int h,int m)
{
    static char function[16];

    sprintf(function,"%2d:%02d",h,m);
    return(function);
}

long TZone = 0L;

void TZ(void)
{
    char *ep;
    int k;
    char tzstr[128];

    daylight = 0;
    timezone = 0L;
    if ((ep = getenv("TZ")) == NULL) {
Default:
	TZone = 28800L;
	return;
    }
    strcpy(tzstr,ep);
    if ((k = strlen(tzstr) - 1) < 3)
	goto Default;
    TZone = atol(&tzstr[3]) * 3600L;
    if ((tzstr[k] < '0')||(tzstr[k] > '9'))
	TZone -= 3600L;
}

long GMT(long local)
{
    return( local + TZone );
}

struct tm LCT(long gmt)
{
    struct tm local;
    time_t wk;

    wk = gmt - TZone;
    local = *(gmtime(&wk));
    return(local);
}

unsigned daynumber(char *s)
{
    char inp[32];
    int month, day, year, slen;
    struct tm dos_tm;

    slen = strlen(s);
    if (slen != 8)
	return(0);
    strcpy(inp,s);
    day    = atoi(&inp[6]);
    inp[6] = 0;
    month  = atoi(&inp[4]);
    inp[4] = 0;
    year   = atoi(&inp[0]);
    if ((month < 1)||(month > 12)||(year < 0)||(day < 1)||(day > 31))
	return(0);
    if (year < 80)
	year += 100;
    if (year > 1900)
	year -= 1900;
    if ((year < 80) || (year > 179))
	return(0);
    dos_tm.tm_year = year;
    dos_tm.tm_mon  = month - 1;
    dos_tm.tm_mday  = day;
    dos_tm.tm_hour =
     dos_tm.tm_min  =
      dos_tm.tm_sec  =
       dos_tm.tm_isdst =
	dos_tm.tm_wday =
	 dos_tm.tm_yday = 0;
    timezone = daylight = 0;
    return( ((unsigned)((mktime(&dos_tm)/86400L)+25569L-29221L)) );
}

int chg_dir(char *p)
{
    char temp[128];
    char wrk[128];
    int j, deslash_it;

    if (!p[0])
	return(0);
    getcwd(temp,80);
    strcpy(wrk,p);
    strupr(wrk);
    deslash_it = 1;
    if (wrk[1] == ':') {
	setdisk((wrk[0] - 'A'));
	if (!wrk[2]) {
	    strcat(wrk,"\\");
	    deslash_it = 0;
	}
    }
    if (deslash_it) {
	if ((j = strlen(wrk) - 1) > 0)
	    if (wrk[j] == '\\')
		wrk[j] = 0;
    }
    if (chdir(wrk)) {
	chg_dir(temp);
	return(-1);
    }
    return(0);
}

int is_blank(int ch)
{
    int ch1;

    ch1 = (ch & 0x00ff);
    return( ((ch1==' ')||(ch1=='\t')||(ch1==0x00ff)) );
}

int is_blank_line(char *s)
{
    int j, ch;

    j = 0;
    while (ch = s[j++]) {
	if ((ch == '\r')||(ch == '\n'))
	    return(1);
	if (!is_blank(ch))
	    return(0);
    }
    return(1);
}

int pos(char *searchtag,char *fulltag)
{
    int i, j, lensrch;

    if (lensrch = strlen(searchtag)) {
	j = strlen(fulltag) - lensrch + 1;
	for (i = 0; i < j; i++) {
	    if (! strncmp(searchtag,(fulltag + i),lensrch))
		return(i);
        }
	return(-1);
    }
    return(0);
}

void delete(char *destin,int start,int size)
{
    int j, m, k;

    if (k = strlen(destin)) {
        j = start - 1;
	destin[j] = 0;
        m = j + size;
	if (m < k)
            strcpy(&destin[j],&destin[m]);
    }
}

void process_pathname(char *p)
{
    int lgth;

    public_area = 0;
    if (p[0]) {
	strupr(p);
	lgth = strlen(p) - 1;
	if (p[lgth] == '\n')
	    p[lgth--] = 0;
	if (p[lgth] == '\r')
	    p[lgth--] = 0;
	if (p[lgth++] != '\\') {
	    p[lgth++] = '\\';
	    p[lgth] = 0;
	}
	if (p[0] == '\\')
	    return;
	while ( (p[0]) && ((p[0] < 'A') || (p[0] > 'Z')) ) {
            if (p[0] == '^')
                public_area = 1;
	    delete(p,1,1);
        }
    }
}

char *build_date2000(int m,int d,int y)
{
    static char date_buffer[16];

    if ((y > 15) && (y < 300))
        y += 1900;
    if (y < 1000) {
        y %= 100;
        y += 2000;
    }
    sprintf(date_buffer,"%04d%02d%02d",y,m,d);
    return(date_buffer);
}

void cvt_to_date2000(char *os,char *is)
{
    int m, d, y, j;
    int ds, ys;
    char ws[32];

    strcpy(ws,is);
    if (!ws[0])
        goto EarlyExit;
    j = pos("-",ws);
    if (j < 0) {
        j = pos("/",ws);
        if (j < 0) {
EarlyExit:
            os[0] = 0;
            return;
        }
    }
    ws[j] = ' ';
    ds = j + 1;
    j = pos("-",ws);
    if (j < 0) {
        j = pos("/",ws);
        if (j < 0)
            goto EarlyExit;
    }
    ws[j] = ' ';
    ys = j + 1;
    m = atoi(ws);
    d = atoi(&ws[ds]);
    y = atoi(&ws[ys]);
    strcpy(os,build_date2000(m,d,y));
}

char *fmt_date2000(char *is)
{
    static char date_buffer[16];

    if (is_blank_line(is)) {
        memset(date_buffer,0,sizeof(date_buffer));
        return(date_buffer);
    }
    date_buffer[0] = is[4];
    date_buffer[1] = is[5];

    date_buffer[2] =
      date_buffer[5] = '-';

    date_buffer[3] = is[6];
    date_buffer[4] = is[7];

    date_buffer[6] = is[0];
    date_buffer[7] = is[1];
    date_buffer[8] = is[2];
    date_buffer[9] = is[3];

    date_buffer[10] = 0;
    if (date_buffer[3] == '0')
        delete(date_buffer,4,1);
    if (date_buffer[0] == '0')
        delete(date_buffer,1,1);
    return(date_buffer);
}

char *fmt2_date2000(char *is)
{
    static char date_buffer[16];

    if (is_blank_line(is)) {
        memset(date_buffer,0,sizeof(date_buffer));
        return(date_buffer);
    }
    date_buffer[0] = is[4];
    date_buffer[1] = is[5];

    date_buffer[2] =
      date_buffer[5] = '-';

    date_buffer[3] = is[6];
    date_buffer[4] = is[7];

    date_buffer[6] = is[0];
    date_buffer[7] = is[1];
    date_buffer[8] = is[2];
    date_buffer[9] = is[3];

    date_buffer[10] = 0;
    if (date_buffer[0] == '0')
        date_buffer[0] = ' ';

    return(date_buffer);
}

int strip_nl(char *s,int imax)
{
    int j, lmax;

    lmax = imax - 1;
    j = 0;
    while ((s[j]) && (s[j] != '\n') && (s[j] != '\r') && (j < lmax))
	j++;
    s[j] = 0;
    return(j);
}

void copy_p(char *ds,char *ss,int k)
{
    int i, j;

    i = 0;
    j = k - 1;
    do {
	if (! (ds[i] = ss[i]))
            return;
    } while (++i < j);
    ds[j] = 0;
}

void insert(char *addstring,char *newstring,int index)
{
    char temp[512];
    int k;

    temp[0] = 0;
    if ((! newstring[0]) || (index > strlen(newstring)))
	;
    else  {
        k = index - 1;
        copy_p(temp,(newstring + k),510);
        newstring[k] = 0;
    }
    strcat(newstring,addstring);
    strcat(newstring,temp);
}

char *trim(char *st)
{
    int i;

    i = 0;
    while (st[i] <= ' ')
       i++;
    if (i)
	delete(st,1,i);
    i = strlen(st);
    do {
       st[i--] = 0;
    } while ((i >= 0) && (st[i] <= ' '));
    return(st);
}

void proper(char *s)
{
    int i, j, k, m;

    trim(s);
    if (!s[0])
	return;
    for (i = 0; s[i]; i++) {
	if ((s[i]<32) || (s[i]==';') || (s[i]=='%'))
	    s[i] = ' ';
    }
    strupr(s);
    i = 0;
    while (s[++i]) {
	if ((s[i] >= 'A') && (s[i] <= 'Z')) {
	    if (s[i] == 'D') {
		j = i - 1;
		k = j - 1;
		m = k - 1;
		if (m >= 0) {
		    if ((s[m]=='M') && (s[k]=='a') && (s[j]=='c'))
			goto ProperLoop;
		}
	    }
	    s[i] = _tolower(s[i]);
	    goto McCheck;
	}
	switch (s[i]) {
	case ',':
	    insert(" ",s,(i+2));
	    break;
	case '-':
	case '_':
	    goto UpperMc;
	case '.':
	    j = i - 1;
	    k = j - 1;
	    if (k >= 0) {
		k = toupper(s[k]);
		if ((k >= 'A') && (k <= 'Z'))
		    break;
	    }
	    s[j] = toupper(s[j]);
	    break;
	case ' ':
	case 39:
	    j = i + 1;
	    while (s[j] == ' ')
		delete(s,(j+1),1);
	    k = strlen(s);
	    if (j < k) {
		s[j] = toupper(s[j]);
		i = j;
	    }
	    break;
	default:
McCheck:
	    if (s[i] == 'c') {
		j = i - 1;
		if (j >= 0) {
		    if (s[j] == 'M')
			goto UpperMc;
		}
	    }
	}
	goto ProperLoop;
UpperMc:
	i++;
	s[i] = toupper(s[i]);
ProperLoop:
	;
    }
}

char *gttime(void)
{
    static char function[16];
    union REGS regs;

    regs.x.ax = 0x2c00;
    intdos(&regs,&regs);
    strcpy(function,build_time(regs.h.ch,regs.h.cl));
    function[5] = 0;
    return(function);
}

char *build_date(int m,int d,int y)
{
    static char date_buffer[16];

    if ((y > 15) && (y < 300))
        y += 1900;
    if (y < 1000) {
        y %= 100;
        y += 2000;
    }
    sprintf(date_buffer,"%2d-%02d-%04d",m,d,y);
    return(date_buffer);
}

char *date2000(void)
{
    union REGS regs;

    regs.x.ax = 0x2a00;
    intdos(&regs,&regs);
    return(build_date2000(regs.h.dh,regs.h.dl,regs.x.cx));
}

char *date(void)
{
    union REGS regs;

    regs.x.ax = 0x2a00;
    intdos(&regs,&regs);
    return(build_date(regs.h.dh,regs.h.dl,regs.x.cx));
}

char *date00(void)
{
    static char date_buffer[16];
    char dwork[16];

    strcpy(dwork,date());
    delete(dwork,7,2);
    strcpy(date_buffer,dwork);
    return(date_buffer);
}

int fgets_p(char *s,int imax,FILE *f)
{
    char *p;

    p = fgets(s,(imax - 3),f);
    if ((p==NULL)||(s[0]==0x1a)) {
	s[0]=0;
	return(-1);
    }
    return((strip_nl(s,imax)));
}

void process_mailbox_msgs(long *msg_count,long *unread_cnt,long *read_cnt)
{
    struct msg_record mr;
    unsigned num_recs, k;
    long flen, rsize;
    int fp, msg_recvd;

    if ((fp = _open("MESSAGE.CTL",o_mode(O_RDONLY))) < 0)
        return;
    flen = filelength(fp);
    rsize = sizeof(struct msg_record);
    num_recs = (unsigned) (flen / rsize);
    if (num_recs <= 1) {
	_close(fp);
        return;
    }
    readfile(fp,(char*) &mr,sizeof(struct msg_record));
    for (k=1; k<num_recs; k++) {
	readfile(fp,(char*) &mr,sizeof(struct msg_record));
        (*msg_count)++;
        msg_recvd = mr.msg_received & 0x0F;
	if ((!mr.msg_deleted)&&(!msg_recvd))
            (*unread_cnt)++;
        else
            (*read_cnt)++;
    }
    _close(fp);
}

void process_mailbox_files(long *k_amount)
{
    char far *dta;
    char buffer[260], pathname[128];
    struct ffblk ffblk;
    int test_value, done;

    dta = getdta();
    setdta(buffer);
//**********
    splice(pathname,"FILES","*.*");
    test_value = (FA_SYSTEM|FA_LABEL|FA_DIREC);
    done = findfirst(pathname,&ffblk,0);
    while (!done) {
	if (ffblk.ff_name[0] != '.') {
	    if (!(ffblk.ff_attrib & test_value))
                *k_amount += ffblk.ff_fsize;
	}
	done = findnext(&ffblk);
    }
//**********
    setdta(dta);
}

void process_mailbox(char *zone_path,char *zone_name,char *box_name)
{
    char far *dta;
    long max_msgs, max_k, max_days;
    int j, k, slen;
    long msg_count, k_amount, read_cnt, unread_cnt;
    char work[514], buffer[260], hold_path[128], box_path[128];
    char owner_name[80];
    FILE *fp;

    dta = getdta();
    setdta(buffer);
    getcwd(hold_path,120);
//**********
    splice(box_path,zone_path,box_name);
    chg_dir(box_path);
    if ((fp = fopen("OWNER.BOX","rt"))==NULL)
        goto ExitMailbox;
    slen = fgets_p(work,512,fp);
    fclose(fp);
    if (slen <= 0)
        goto ExitMailbox;
    max_k    = default_max_k;
    max_msgs = default_max_msgs;
    max_days = default_max_days;
    if ((j = pos(",",work)) > 0) {
        work[j++] = 0;
        max_msgs = atol(&work[j]);
        if ((k = pos(",",&work[j])) > 0) {
            j += k;
            work[j++] = 0;
            max_days = atol(&work[j]);
            if ((k = pos(",",&work[j])) > 0) {
                j += k;
                work[j++] = 0;
                max_k = atol(&work[j]);
            }
        }
    }
    strncpy(owner_name,work,31);
    owner_name[30] = 0;
    msg_count =
        k_amount =
            read_cnt =
                unread_cnt = 0;
    process_mailbox_msgs(&msg_count,&unread_cnt,&read_cnt);
    process_mailbox_files(&k_amount);
    k_amount = (k_amount + 512) / 1024;
    mailbox_count++;
    sprintf(work,"%2ld %2ld %2ld",read_cnt,unread_cnt,msg_count);
    fprintf(report,"\n  Box: %-8s  Own: %-21s  Msgs R/U/T:%-9s  K:%ld",
        box_name,owner_name,work,k_amount);
    if (k_amount > max_k)
        fprintf(report,"\n**** WARNING: exceeds the K limit of %ld.\n",max_k);
    if (msg_count > 0) {
        sprintf(work,"DELREN /B %s %ld /D%ld /FAST >nul",
            box_path,
             max_msgs,
              max_days);
        system(work);
    }
//**********
ExitMailbox:
    chg_dir(hold_path);
    setdta(dta);
}

void process_mailbox_zone(char *zone_name)
{
    char far *dta;
    char buffer[260], zone_path[128], pathname[128], hold_path[128];
    struct ffblk ffblk;
    int done;

    fprintf(report,"\nZone: %s",zone_name);
    dta = getdta();
    setdta(buffer);
    getcwd(hold_path,120);
    splice(zone_path,mailbox_dir,zone_name);
    chg_dir(zone_path);
    splice(pathname,zone_path,"*.*");
    done = findfirst(pathname,&ffblk,FA_DIREC);
    while (!done) {
	if (ffblk.ff_name[0] != '.') {
	    if (ffblk.ff_attrib & FA_DIREC)
                process_mailbox(zone_path,zone_name,ffblk.ff_name);
	}
	done = findnext(&ffblk);
    }
    fprintf(report,"\n");
    chg_dir(hold_path);
    setdta(dta);
}

FILE *sfopen(char *fname)
{
    int handle, loop, access;

    access = o_mode(O_RDONLY);
    for (loop=0; loop<30; loop++) {
	if ((handle = open(fname,access)) >= 0)
	    return( fdopen(handle,"rt") );
	if ((lan_path[0]) && (errno == EACCES)) {
	    sleep(1);
	}
	else {
	    if (errno != ENOENT)
		prt_error("open",fname);
	    break;
	}
    }
    return(NULL);
}

long filesize(FILE *fptr)
{
    long length;

    fseek(fptr,0L,SEEK_END);
    length = ftell(fptr);
    fseek(fptr,0L,SEEK_SET);
    return(length);
}

void lock_msg_base(int msg_control_file)
{
    if (lan_path[0])
	lock(msg_control_file,0L,(long) sizeof(struct msg_record));
}

void unlock_msg_base(int msg_control_file)
{
    if (lan_path[0])
	unlock(msg_control_file,0L,(long) sizeof(struct msg_record));
}

void store_msg(
    char *tmp_name,
    char *msg_path,
    struct msg_record *mr
    )
{
    unsigned msav, base, sub, old_file, k;
    long m_offset, lpos, rsize;
    unsigned msg_file_ptr;
    char temp[272];
    char msg_ctl_name[128];
    int eof_char1, eof_char2;
    int msg_control_file;
    FILE *t_handle;
    FILE *w_handle;
    struct msg_record mcr;
    int slen;

    w_handle = NULL;
    t_handle = NULL;
    splice(msg_ctl_name,msg_path,"MESSAGE.CTL");
    msg_control_file = _open(msg_ctl_name,o_mode(O_RDWR));
    if (msg_control_file < 0) {
	msg_control_file = createfile(msg_ctl_name);
	memset(&mcr,0,sizeof(struct msg_record));
	mcr.msg_deleted = FALSE;
	strcpy(mcr.msg_addressee,"SYS CTL");
	strcpy(mcr.msg_date,date00());
        strcpy(temp,gttime());
        temp[5] = 0;
	strcpy(mcr.msg_time,temp);
	mcr.msg_perm_priv = 1;
	mcr.msg_received = 0;
	_write(msg_control_file,(void*) &mcr,sizeof(struct msg_record));
        _close(msg_control_file);
	msg_control_file = _open(msg_ctl_name,o_mode(O_RDWR));
    }
    lock_msg_base(msg_control_file);
    readfile(msg_control_file,(void*) &mcr,sizeof(struct msg_record));
    lpos  = filelength(msg_control_file);
    rsize = sizeof(struct msg_record);
    msg_file_ptr = (unsigned)(lpos / rsize);
    msav = mcr.msg_number + msg_file_ptr;
    k = (msav - 1);
    base = (k / 10) + 1;
    sub = k % 10;
    sprintf(temp,"%s\\GTMSGS\\%05u.MES",msg_path,base);
    old_file = 1;
    if ((t_handle = fopen(temp,"r+b")) == NULL) {
	old_file = 0;
	if ((t_handle = fopen(temp,"wb")) == NULL) {
	    goto StorExit;
	}
    }
    if (old_file) {
	if ((m_offset = filesize(t_handle) - 2L) > 0L) {
	    fseek(t_handle,m_offset,SEEK_SET);
	    eof_char1 = fgetc(t_handle);
	    eof_char2 = fgetc(t_handle);
	    m_offset += 2;
	    if ((eof_char2 == 26)||(eof_char2 == EOF))
		m_offset--;
	    fseek(t_handle,m_offset,SEEK_SET);
	    if ((eof_char1 != 10) && (eof_char1 != 13)) {
		if ((eof_char2 != 10) && (eof_char2 != 13)) {
		    fputs("\r\n",t_handle);
		}
	    }
	}
    }
    mcr = *mr;
    mcr.msg_number = msav;
    seekfile(msg_control_file,lpos,SEEK_SET);
    writefile(msg_control_file,(void*) &mcr,rsize);
    fprintf(t_handle,"\x18SOM%u\r\n",sub);
    w_handle = fopen(tmp_name,"rt");
    if (w_handle == NULL)
	goto close_mes_file;
    do {
	slen = fgets_p(temp,258,w_handle);
        if (slen >= 0)
            fprintf(t_handle,"%s\r\n",temp);
    } while (slen >= 0);
close_mes_file:
    fclose(t_handle);
    if (w_handle != NULL)
	fclose(w_handle);
StorExit:
    unlock_msg_base(msg_control_file);
    _close(msg_control_file);
}

#define MXP 15

char p_path[128]      = "";
int cbase;
int p_cnt;
long csize;
int p_base[MXP];
int p_sub[MXP];
long p_offset[MXP];
long p_size[MXP];

FILE *open_msg_rd(
    char *msg_path,
    unsigned m_number,
    int *base,
    int *sub
    )
{
    unsigned k;
    int ksub;
    FILE *m_handle;
    int wsub;
    long woffset;
    char fname[128];

    k = (m_number - 1);
    *base = (k / 10) + 1;
    *sub = k % 10;
    sprintf(fname,"%s\\GTMSGS\\%05u.MES",msg_path,*base);
    if ((m_handle = sfopen(fname)) != NULL) {
        cbase = *base;
	csize = filesize(m_handle);
	if (strcmp(msg_path,p_path)) {
	    for (k=0; k<MXP; k++) {
	        p_size[k] =
                  p_offset[k] =
                    p_base[k] =
                      p_sub[k] = 0;
	    }
            p_cnt = 0;
	    strcpy(p_path,msg_path);
        }
        else {
	    woffset = wsub = 0;
	    for (k=0; k<MXP; k++) {
                if ((csize == p_size[k]) && (*base == p_base[k])) {
		    ksub = p_sub[k];
		    if ((*sub >= ksub) && (wsub < ksub)) {
		        wsub = ksub;
		        woffset = p_offset[k];
		        if (*sub == ksub)
			    k = MXP;
		    }
	        }
	    }
	    if (woffset > 0L)
                fseek(m_handle,woffset,SEEK_SET);
        }
    }
    return(m_handle);
}

int read_mes(char *buf,FILE *m_handle,int sub,int *csub)
{
    int j, pp;
    int ramt, not_oldie;
    long woffset;

    do {
	if ((ramt = fgets_p(buf,258,m_handle)) > -1) {
	    if ((ramt==5)&&(buf[0]==24)&&(buf[1]=='S')&&(buf[2]=='O')&&(buf[3]=='M')){
		*csub = buf[4] - 48;
		if ((woffset = ftell(m_handle) - 8) > 0L) {
		    pp = p_cnt;
		    not_oldie = 1;
		    for (j=0; j<MXP; j++) {
			if ((p_base[j] == cbase) && (p_sub[j] == *csub)) {
			    pp = j;
			    not_oldie = 0;
			    break;
			}
		    }
		    p_size[pp] = csize;
		    p_base[pp] = cbase;
		    p_sub[pp] = *csub;
		    p_offset[pp] = woffset;
		    if (not_oldie) {
			if (++p_cnt >= MXP)
			    p_cnt = 0;
		    }
		}
		if (*csub > sub)
		    ramt = -1;
	    }
	    else {
		if (*csub == sub)
		    return(ramt);
	    }
	}
    } while (ramt > -1);
    return(-1);
}

void mailbox_sender(
    char *curr_msg_path,
    unsigned msg_wanted,
    char *new_msg_path,
    struct msg_record *mr
    )
{
    char text[262], tmp_filename[128];
    FILE *org_handle;
    FILE *tmp_handle;
    int base, sub, csub, slen;
    struct msg_record mcr;

    csub = 0xffff;
    if ((org_handle = open_msg_rd(curr_msg_path,msg_wanted,&base,&sub))==NULL)
	goto SenderExit;
    splice(tmp_filename,new_msg_path,"$$MBMGR");
    if ((tmp_handle = fopen(tmp_filename,"wt")) == NULL) {
	fclose(org_handle);
	goto SenderExit;
    }
    do {
	slen = read_mes(text,org_handle,sub,&csub);
	if (slen >= 0)
	    fprintf(tmp_handle,"%s\n",text);
    } while (slen >= 0);
    fclose(org_handle);
    fclose(tmp_handle);
    mcr = *mr;
    mcr.msg_reply_no[0] =
      mcr.msg_reply_no[1] =
	mcr.msg_reply_no[2] =
	  mcr.msg_orig_no = 0;
    store_msg(tmp_filename,new_msg_path,&mcr);
    unlink(tmp_filename);
SenderExit:
    return;
}

void construct_mailbox_path(char *os,char *s,unsigned long nbr)
{
    unsigned long box_nbr;
    char zone[80], box[128];

    box_nbr = nbr / 300 + 1;
    sprintf(zone,"%04ld",box_nbr);
    splice(box,mailbox_dir,zone);
    splice(os,box,s);
}

void send_to_mailbox(char *msg_path,struct msg_record *mr,DRAM *ufcb)
{
    int ch;
    USER_RECORD *up;
    char mailbox_path[128];

    up = ufcb->user_rec;
    strcpy(ufcb->string_key,mr->msg_addressee);
    if (!dram(READ,ufcb)) {
        ch = up->user_mailbox_name[0] & 0x00FF;
        if ((ch) && (ch != ' ') && (ch != 0xFF)) {
            construct_mailbox_path(mailbox_path,up->user_mailbox_name,up->user_caller_no);
            if (dexist(mailbox_path)) {
                mailbox_sender(msg_path,mr->msg_number,mailbox_path,mr);
            }
        }
    }
}

void process_to_mailboxes(char *msg_path,DRAM *ufcb)
{
    char msg_control_fname[128];
    struct msg_record mr;
    unsigned num_recs, k;
    long flen, rsize, lpos;
    int fp, msg_mailboxed, msg_recvd;

    splice(msg_control_fname,msg_path,"MESSAGE.CTL");
    if ((fp = _open(msg_control_fname,o_mode(O_RDWR))) < 0)
        return;
    flen = filelength(fp);
    rsize = sizeof(struct msg_record);
    num_recs = (unsigned) (flen / rsize);
    if (num_recs <= 1) {
	_close(fp);
        return;
    }
    readfile(fp,(char*) &mr,sizeof(struct msg_record));
    for (k=1; k<num_recs; k++) {
        lpos = ((long) k) * ((long) sizeof(struct msg_record));
        seekfile(fp,lpos,SEEK_SET);
	readfile(fp,(char*) &mr,sizeof(struct msg_record));
        msg_mailboxed = mr.msg_flags    & 0x08;
        msg_recvd     = mr.msg_received & 0x0F;
	if ((!msg_recvd)&&(!mr.msg_deleted)&&(!mr.msg_dest_net)&&(!msg_mailboxed)) {
            mr.msg_flags |= 0x08;
            seekfile(fp,lpos,SEEK_SET);
            writefile(fp,(char*) &mr,sizeof(struct msg_record));
            send_to_mailbox(msg_path,&mr,ufcb);
        }
    }
    _close(fp);
}

void scan_msg_bases(void)
{
    int j, slen;
    char gtmdir[128], msg_path[128], wrk[262];
    char previous_msg_path[128];
    FILE *fd;
    DRAM *ufcb;

    ufcb = allocate_fcb();
    ufcb->dat_recsize = sizeof(USER_RECORD);
    ufcb->dat_keypos = 1;
    ufcb->dat_keytype = 0;
    strcpy(ufcb->dram_path,lan_path);
    dram_slasher(ufcb);
    strcpy(ufcb->dram_fname,"_USER");
    if (dram(OPEN,ufcb)) {
	printf("\nERROR: cannot open _USER files.\n");
        sleep(5);
	return;
    }
    splice(gtmdir,gtpath,"GTMDIR.BBS");
    if ((fd = fopen(gtmdir,"rt")) == NULL) {
	splice(gtmdir,bbs_path,"GTMDIR.BBS");
	if ((fd = fopen(gtmdir,"rt")) == NULL) {
	    printf("\nERROR: Cannot find the GTMDIR.BBS file.\n");
	    sleep(5);
	    goto CloseDram;
	}
    }
    memset(previous_msg_path,0,sizeof(previous_msg_path));
    printf("\n");
    do {
	slen = fgets_p(wrk,260,fd);
	if (slen > 5) {
	    if (wrk[0] == '.')
                continue;
	    if (wrk[0] > ' ') {
		while ((wrk[0] != ' ') && (wrk[0]))
		    delete(wrk,1,1);
	        while (wrk[0] == ' ')
		    delete(wrk,1,1);
		if ((j = pos(" ",wrk)))
		    wrk[j] = 0;
		if ((j = pos(",",wrk)))
		    wrk[j] = 0;
		wrk[79] = 0;
		strcpy(msg_path,wrk);
		process_pathname(msg_path);
		if (!strcmp(previous_msg_path,msg_path))
		    continue;
	        strcpy(previous_msg_path,msg_path);
                if (!public_area) {
                    printf("\nScanning: %s",msg_path);
                    process_to_mailboxes(msg_path,ufcb);
                }
	    }
	}
    } while (slen >= 0);
    fclose(fd);
CloseDram:
    dram(CLOSE,ufcb);
    release_fcb(ufcb);
    printf("\n\n");
}

void show_help_screen(void)
{
    printf("\n\n USAGE: mbmgr [/M:mmm] [/K:nnnn] [/S]");
    printf("\n\n     where:  /M:mmm   defines the max number of messages");
    printf(  "\n                      per mailbox.");
    printf("\n\n             /K:nnnn  defines the max number of kilobytes");
    printf(  "\n                      per mailbox.");
    printf("\n\n             /D:aaaa  defines the max age of messages in");
    printf(  "\n                      the mailbox.");
    printf("\n\n             /S       scan message bases and import to mailboxes.");
    printf("\n\n");
}

typedef char string140[142];
typedef string140 PAGE_REASONS[3];

void main(int argc,char *argv[])
{
    FILE *text;
    char wrk[514], hold_path[128], buffer[260], pathname[128];
    char *ep;
    struct ffblk ffblk;
    char far *dta;
    int ramt, done, j, scanner;

    printf("\nMailbox Manager 1.0, (C)1994 P&M Software Co, All Rights Reserved.\n");
    TZ();
    scanner = 0;
    for (j=1; j<argc; j++) {
         strcpy(wrk,argv[j]);
         strupr(wrk);
         if (wrk[0]=='?') {
HelpExit:
             show_help_screen();
             exit(0);
         }
         if ((wrk[0]=='/')||(wrk[0]=='-')) {
             if (wrk[1]=='?')
                 goto HelpExit;
             if (wrk[2]==':')
                 delete(wrk,2,1);
             if (wrk[1]=='K')
                 default_max_k    = atol(&wrk[2]);
             if (wrk[1]=='M')
                 default_max_msgs = atol(&wrk[2]);
             if (wrk[1]=='D')
                 default_max_days = atol(&wrk[2]);
             if (wrk[1]=='S')
                 scanner = 1;
         }
    }
    if ((ep = getenv("GTPATH")) != NULL)
	strcpy(gtpath,ep);
    else
	getcwd(gtpath,80);
    process_pathname(gtpath);
    splice(wrk,gtpath,"GT.CNF");
    strcpy(lan_path,gtpath);
    if ((text = fopen(wrk,"rt")) != NULL) {
	do {
	    if ((ramt = fgets_p(wrk,512,text)) > 0) {
		strupr(wrk);
		if ((wrk[2] == '=') && (wrk[3] >= 'A') && (wrk[3] <= 'Z')) {
                    if ((wrk[0] == 'M') && (wrk[1] == 'A')) {
                        strcpy(mailbox_dir,&wrk[3]);
                        process_pathname(mailbox_dir);
                        continue;
                    }
		    if ((wrk[0] == 'L') && (wrk[1] == 'R')) {
			strcpy(lan_path,&wrk[3]);
			process_pathname(lan_path);
			continue;
		    }
		    if ((wrk[0] == 'B') && (wrk[1] == 'B')) {
			strcpy(bbs_path,&wrk[3]);
			process_pathname(bbs_path);
			continue;
		    }
		}
	    }
	} while (ramt >= 0);
	fclose(text);
    }
    if (scanner)
        scan_msg_bases();
    splice(wrk,gtpath,"MAILBOX.RPT");
    if ((report = fopen(wrk,"wt")) == NULL) {
        prt_error("open",wrk);
        exit(1);
    }
    printf("\nCreating Mailbox Report...\n");
    fprintf(report,"\nMailbox Report: %s %s\n",date(),gttime());
    dta = getdta();
    setdta(buffer);
    getcwd(hold_path,120);
    chg_dir(mailbox_dir);
    splice(pathname,mailbox_dir,"*.*");
    done = findfirst(pathname,&ffblk,FA_DIREC);
    mailbox_count = 0;
    while (!done) {
	if (ffblk.ff_name[0] != '.') {
	    if (ffblk.ff_attrib & FA_DIREC) {
                if (atol(ffblk.ff_name) > 0) {
                    printf("\nProcessing Mailbox Zone: %s",ffblk.ff_name);
                    process_mailbox_zone(ffblk.ff_name);
                }
	    }
	}
	done = findnext(&ffblk);
    }
    chg_dir(hold_path);
    setdta(dta);
    sprintf(wrk,"\n\nMailbox Count = %ld\n",mailbox_count);
    fprintf(report,"%s",wrk);
    fclose(report);
    printf("%s",wrk);
    exit(0);
}
